<script setup lang="ts">
import { computed } from "vue";
import MarkdownRenderer from "@/components/MarkdownRenderer.vue";
import ParameterSchemaDescriptionComponent from "@/components/parameter-schema/ParameterSchemaDescriptionComponent.vue";
import { useRoute } from "vue-router";
import type { ClowmInfo } from "@/types/ClowmInfo";
import type { ParameterExtensionOutput } from "@/client/types.gen.ts";

const route = useRoute();

const props = defineProps<{
  loading: boolean;
  descriptionMarkdown?: string;
  changelogMarkdown?: string;
  usageMarkdown?: string;
  outputMarkdown?: string;
  citationsMarkdown?: string;
  parameterSchema?: Record<string, never>;
  parameterExtension?: ParameterExtensionOutput | null;
  clowmInfo?: ClowmInfo;
}>();

const activeTab = computed<string>(
  () => (route.query["tab"] as string) ?? "description",
);
</script>

<template>
  <ul class="nav justify-content-evenly nav-tabs fs-5">
    <li class="nav-item">
      <router-link
        class="nav-link"
        aria-current="page"
        replace
        :to="{ query: { ...route.query, tab: 'description' } }"
        :class="{
          active: activeTab === 'description',
          disabled: !props.descriptionMarkdown,
        }"
        >Description
      </router-link>
    </li>
    <li class="nav-item">
      <router-link
        class="nav-link"
        replace
        :to="{ query: { ...route.query, tab: 'usage' } }"
        :class="{
          active: activeTab === 'usage',
          disabled: !props.usageMarkdown,
        }"
        >Usage
      </router-link>
    </li>
    <li class="nav-item">
      <router-link
        class="nav-link"
        replace
        :to="{ query: { ...route.query, tab: 'parameters' } }"
        :class="{
          active: activeTab === 'parameters',
          disabled: !props.parameterSchema,
        }"
        >Parameters
      </router-link>
    </li>
    <li class="nav-item">
      <router-link
        class="nav-link"
        replace
        :to="{ query: { ...route.query, tab: 'output' } }"
        :class="{
          active: activeTab === 'output',
          disabled: !props.outputMarkdown,
        }"
        >Output
      </router-link>
    </li>
    <li
      v-if="
        props.citationsMarkdown != undefined &&
        props.citationsMarkdown.length > 0
      "
      class="nav-item"
    >
      <router-link
        class="nav-link"
        replace
        :to="{ query: { ...route.query, tab: 'citation' } }"
        :class="{
          active: activeTab === 'citation',
        }"
        >Citations
      </router-link>
    </li>
    <li class="nav-item">
      <router-link
        class="nav-link"
        replace
        :to="{ query: { ...route.query, tab: 'changes' } }"
        :class="{
          active: activeTab === 'changes',
          disabled: !props.changelogMarkdown,
        }"
        >Releases
      </router-link>
    </li>
  </ul>
  <div v-if="props.loading" class="pt-3 border border-top-0 px-2">
    <p class="placeholder-glow mt-2 mb-4">
      <span class="placeholder col-7 fs-1"></span>
    </p>
    <p
      v-for="n in 8"
      :key="n"
      class="placeholder-glow row ms-1"
      :class="'my-' + Math.floor(Math.random() * 6)"
    >
      <span
        class="placeholder"
        :class="'col-' + Math.floor(Math.random() * 9 + 2)"
      ></span>
    </p>
  </div>
  <div
    v-else
    class="px-2 pt-3 border border-top-0"
    :class="{ 'overflow-x-auto': activeTab !== 'parameters' }"
  >
    <div v-if="activeTab === 'description'">
      <markdown-renderer
        v-if="props.descriptionMarkdown"
        :markdown="props.descriptionMarkdown"
      />
      <h4 v-else class="text-center mt-5">Description is not available</h4>
    </div>
    <template v-else-if="activeTab === 'parameters'">
      <parameter-schema-description-component
        v-if="props.parameterSchema"
        :schema="props.parameterSchema"
        :clowm-info="props.clowmInfo"
        :parameter-visibility="
          Object.keys(parameterExtension?.parameter_visibility ?? {}).length > 0
            ? parameterExtension!.parameter_visibility
            : undefined
        "
      />
      <h4 v-else class="text-center mt-5">Parameters are not available</h4>
    </template>
    <div v-else-if="activeTab === 'changes'">
      <markdown-renderer
        v-if="props.changelogMarkdown"
        :markdown="props.changelogMarkdown"
      />
      <h4 v-else class="text-center mt-5">Changelog is not available</h4>
    </div>
    <div v-else-if="activeTab === 'output'">
      <markdown-renderer
        v-if="props.outputMarkdown"
        :markdown="props.outputMarkdown"
      />
      <h4 v-else class="text-center mt-5">Output is not available</h4>
    </div>
    <div v-else-if="activeTab === 'usage'">
      <markdown-renderer
        v-if="props.usageMarkdown"
        :markdown="props.usageMarkdown"
      />
      <h4 v-else class="text-center mt-5">Usage is not available</h4>
    </div>
    <div v-else-if="activeTab === 'citation'">
      <markdown-renderer :markdown="props.citationsMarkdown" />
    </div>
  </div>
</template>

<style scoped></style>
